package jeu;
import java.util.*;
/**
 * Une coordonnée sur une grille.
 *
 * @author Pierre Courtieu
 * @version 1.0
    */

public class Coordonnees {

    private int x;
    private int y;

    public Coordonnees(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public boolean equals(Coordonnees c) {
        return (this.x == c.getX() && this.y == c.getY());
    }

    /* SOLUTION (rien) */
    public String toString(){
        return "("+this.x+ "," + this.y+")";
    }
    /* FIN SOLUTION */

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }
    
    public int hashCode() {
        return this.x + this.y *31;
    }

    /* EXEMPLE DE MÉTHODE UTILE */
    /**  {@code c.h()} retourne la coordonnées de la case juste
     * au-dessus de la case (this). */
    public Coordonnees h() {
        return new Coordonnees(this.x, this.y - 1);
    }
    /* SOLUTION (rien) */
    /** {@code c.hg()} retourne la coordonnées de la case juste
     * en haut à gauche de la case {@code c}. */
    public Coordonnees hg() {
        return new Coordonnees(this.x - 1, this.y - 1);
    }

    /** {@code c.hd()} retourne la coordonnées de la case juste
     * en haut à droite de la case {@code c}. */
    public Coordonnees hd() {
        return new Coordonnees(this.x + 1, this.y - 1);
    }

    /** {@code c.g()} retourne la coordonnées de la case juste
     * à gauche de la case {@code c}. */
    public Coordonnees g() {
        return new Coordonnees(this.x - 1, this.y);
    }

    /** {@code c.d()} retourne la coordonnées de la case juste
     * à droite de la case {@code c}. */
    public Coordonnees d() {
        return new Coordonnees(this.x + 1, this.y);
    }
    /** {@code c.b()} retourne la coordonnées de la case juste
     * en-dessous de la case {@code c}. */
    public Coordonnees b() {
        return new Coordonnees(this.x, this.y + 1);
    }
    /** {@code c.bg()} retourne la coordonnées de la case juste
     * en-dessous à gauche de la case {@code c}. */
    public Coordonnees bg() {
        return new Coordonnees(this.x - 1, this.y + 1);
    }
    /** {@code c.bd()} retourne la coordonnées de la case juste
     * en-dessous à droite de la case {@code c}. */
    public Coordonnees bd() {
        return new Coordonnees(this.x + 1, this.y + 1);
    }

    /** {@code c1.estH(c2)} retourne {@code true} si {@code c1}
     * est la coordonnée juste au dessus de {@code c2}. */
    public boolean estH(Coordonnees c) {
        return (c.getX() == this.x && c.getY() - 1 == this.y);
    }

    /** Identique à <code>estH</code>, en haut à gauche. */
    public boolean estHG(Coordonnees c) {
        return (c.getX() - 1 == this.x && c.getY() - 1 == this.y);
    }

    /** Identique à <code>estH</code>, en haut à droite. */
    public boolean estHD(Coordonnees c) {
        return (c.getX() + 1 == this.x && c.getY() - 1 == this.y);
    }

    /** Identique à <code>estH</code>, à gauche. */
    public boolean estG(Coordonnees c) {
        return (c.getX() - 1 == this.x && c.getY() == this.y);
    }

    /** Identique à <code>estH</code>, à droite. */
    public boolean estD(Coordonnees c) {
        return (c.getX() + 1 == this.x && c.getY() == this.y);
    }

    /** Identique à <code>estH</code>, en bas. */
    public boolean estB(Coordonnees c) {
        return (c.getX() == this.x && c.getY() + 1 == this.y);
    }

    /** Identique à <code>estH</code>, en bas à gauche. */
    public boolean estBG(Coordonnees c) {
        return (c.getX() - 1 == this.x && c.getY() + 1 == this.y);
    }

    /** Identique à <code>estH</code>, en bas à droite. */
    public boolean estBD(Coordonnees c) {
        return (c.getX() + 1 == this.x && c.getY() + 1 == this.y);
    }
    /* FIN SOLUTION */

}
